%global mysql_socket /var/lib/mysql/mysql.sock

Name:           mysql-connector-c
Summary:        A client library for connecting to the MySQL database server
Group:          Applications/Databases
Version:        6.1.11
Release:        1%{?dist}
License:        GPLv2+
Source:         http://www.mysql.com/Downloads/Connector-C/%{name}-%{version}-src.tar.gz
URL:            http://www.mysql.com/
Patch0:         mysql-connector-c-openssl11.patch
BuildRequires:  cmake
BuildRequires:  gcc-c++ gperf
BuildRequires:  libaio-devel
BuildRequires:  ncurses-devel
BuildRequires:  compat-openssl10-devel
#BuildRequires:  openssl-devel
BuildRequires:  perl
BuildRequires:  time
BuildRequires:  zlib-devel

# From the manual
%description
This package contains the standard MySQL clients tools, client libraries
and administration tools.


%package devel
Summary:	MySQL - Development header files and libraries
Group:		Applications/Databases
Requires: %{name} = %{version}-%{release}

%description devel
This package contains the development header files and static libraries
necessary to develop MySQL client applications.


%prep
%setup -n %{name}-%{version}-src
#%patch0 -p1 -b .openssl11

##############################################################################
%build

# Be strict about variables, bail at earliest opportunity, etc.
set -eu

# Optional package files
touch optional-files-devel

export CFLAGS=${CFLAGS:-$RPM_OPT_FLAGS -Wno-implicit-fallthrough -Wno-deprecated-declarations}
export CXXFLAGS=${CXXFLAGS:-$RPM_OPT_FLAGS -felide-constructors -Wno-implicit-fallthrough -Wno-deprecated-declarations}

# Build full release
mkdir release
(
  cd release
  cmake ../ -DBUILD_CONFIG=mysql_release -DINSTALL_LAYOUT=RPM \
        -DCMAKE_BUILD_TYPE=RelWithDebInfo \
        -DMYSQL_UNIX_ADDR="%{mysql_socket}" \
        -DFEATURE_SET="community" \
        -DWITH_SSL=%{_prefix}
  make %{?_smp_mflags} VERBOSE=1
)

##############################################################################
%install

# Ensure that needed directories exists
install -d %{buildroot}%{_includedir}
install -d %{buildroot}%{_libdir}
install -d %{buildroot}%{_libdir}/mysql
install -d %{buildroot}%{_mandir}

# Install all binaries
(
  cd release
  make DESTDIR=%{buildroot} install
)

# FIXME: at some point we should stop doing this and just install everything
# FIXME: directly into %{_libdir}/mysql - perhaps at the same time as renaming
# FIXME: the shared libraries to use libmysql*-$major.$minor.so syntax
mv -v %{buildroot}/%{_libdir}/*.a %{buildroot}/%{_libdir}/mysql/

# Remove binaries that in MySQL Server RPMs belongs to the server
# sub RPM, and then will conflict/overwrite
# FIXME move to lib/mysql or remove if/when trying to coexist
# with the server RPM?
rm -f %{buildroot}/%{_bindir}/mysql_config
rm -f %{buildroot}/%{_bindir}/my_print_defaults
rm -f %{buildroot}/%{_bindir}/perror


%files devel
%doc README
%doc COPYING
%doc Docs/INFO_SRC*
%doc release/Docs/INFO_BIN*
#%attr(755, root, root) %{_bindir}/mysql_config
#%attr(755, root, root) %{_bindir}/my_print_defaults
#%attr(755, root, root) %{_bindir}/perror
%dir %attr(755, root, root) %{_includedir}/mysql
%dir %attr(755, root, root) %{_libdir}/mysql
%{_includedir}/mysql/*
%{_libdir}/mysql/libmysqlclient.a
%{_libdir}/libmysql*.so

# ----------------------------------------------------------------------------
%files
%doc README
%doc COPYING
%doc Docs/INFO_SRC*
%doc release/Docs/INFO_BIN*
%{_libdir}/libmysql*.so.*

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%changelog
* Mon Oct 09 2017 Honza Horak <hhorak@redhat.com> - 6.1.11-1
- Initial packaging
